'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const ohmyfetch = require('ohmyfetch');
const defu = require('defu');
const ufo = require('ufo');

const payloadMethods = [
  "POST",
  "PUT",
  "DELETE",
  "PATCH"
];
function createClient(defaultOptions = {}) {
  const internalTarget = () => {
  };
  function p(url) {
    return new Proxy(internalTarget, {
      get(_target, key) {
        const method = key.toUpperCase();
        if (!["GET", ...payloadMethods].includes(method)) {
          return p(ufo.resolveURL(url, key));
        }
        const handler = (data, opts = {}) => {
          if (method === "GET" && data) {
            url = ufo.withQuery(url, data);
          } else if (payloadMethods.includes(method)) {
            opts.body = data;
          }
          opts.method = method;
          return ohmyfetch.$fetch(url, defu.defu(opts, defaultOptions));
        };
        return handler;
      },
      apply(_target, _thisArg, args = []) {
        return p(ufo.resolveURL(url, ...args.map((i) => `${i}`)));
      }
    });
  }
  return p(defaultOptions.baseURL || "/");
}

exports.createClient = createClient;
