import { $fetch } from 'ohmyfetch';
import { defu } from 'defu';
import { resolveURL, withQuery } from 'ufo';

const payloadMethods = [
  "POST",
  "PUT",
  "DELETE",
  "PATCH"
];
function createClient(defaultOptions = {}) {
  const internalTarget = () => {
  };
  function p(url) {
    return new Proxy(internalTarget, {
      get(_target, key) {
        const method = key.toUpperCase();
        if (!["GET", ...payloadMethods].includes(method)) {
          return p(resolveURL(url, key));
        }
        const handler = (data, opts = {}) => {
          if (method === "GET" && data) {
            url = withQuery(url, data);
          } else if (payloadMethods.includes(method)) {
            opts.body = data;
          }
          opts.method = method;
          return $fetch(url, defu(opts, defaultOptions));
        };
        return handler;
      },
      apply(_target, _thisArg, args = []) {
        return p(resolveURL(url, ...args.map((i) => `${i}`)));
      }
    });
  }
  return p(defaultOptions.baseURL || "/");
}

export { createClient };
